"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.askGithubCredentials = exports.githubCredentials = void 0;
const tslib_1 = require("tslib");
const inquirer_1 = tslib_1.__importDefault(require("inquirer"));
const validators_1 = require("../validators");
exports.githubCredentials = [
    {
        name: 'username',
        type: 'input',
        message: 'GitHub username or e-mail',
        validate: validators_1.githubUsernameOrEmail,
    },
    {
        name: 'password',
        type: 'password',
        message: 'GitHub password',
        validate: validators_1.password,
    },
];
const askGithubCredentials = () => inquirer_1.default.prompt(exports.githubCredentials);
exports.askGithubCredentials = askGithubCredentials;
