"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.downloadJson = exports.downloadBinary = exports.createDownloadInit = exports.responseNotOk = exports.HttpStatusCode = exports.fetch = exports.insecureHttpsAgent = exports.httpsAgent = exports.httpAgent = void 0;
const tslib_1 = require("tslib");
const http_1 = tslib_1.__importDefault(require("http"));
const https_1 = tslib_1.__importDefault(require("https"));
const node_fetch_1 = tslib_1.__importDefault(require("node-fetch"));
exports.fetch = node_fetch_1.default;
const store_1 = require("../store");
const utils_1 = require("./utils");
const fetchArgs = utils_1.argv;
exports.httpAgent = new http_1.default.Agent({
    keepAlive: true,
});
exports.httpsAgent = new https_1.default.Agent({
    keepAlive: true,
});
exports.insecureHttpsAgent = new https_1.default.Agent({
    keepAlive: true,
    rejectUnauthorized: false,
});
function getHttpAgent({ protocol }) {
    if (protocol === 'https:') {
        return fetchArgs.insecure ? exports.insecureHttpsAgent : exports.httpsAgent;
    }
    return exports.httpAgent;
}
var HttpStatusCode;
(function (HttpStatusCode) {
    HttpStatusCode[HttpStatusCode["unauthorized"] = 401] = "unauthorized";
})(HttpStatusCode = exports.HttpStatusCode || (exports.HttpStatusCode = {}));
const responseNotOk = (response, msg) => {
    if (response.status === 401 /* HttpStatusCode.unauthorized */) {
        store_1.configStore.values.jfrog.clearToken();
    }
    return new Error(`${msg}, server returned ${response.status} ${response.statusText}`);
};
exports.responseNotOk = responseNotOk;
const createDownloadInit = (token, tokenType = 'Bearer', contentType = 'application/octet-stream') => ({
    redirect: 'follow',
    follow: 10,
    headers: {
        'Content-Type': contentType,
        Authorization: `${tokenType} ${token}`,
        'Access-Control-Expose-Headers': 'Content-Disposition',
    },
    agent: getHttpAgent,
});
exports.createDownloadInit = createDownloadInit;
const downloadBinary = (url, authToken = store_1.configStore.values.jfrog.token, authTokenType = store_1.configStore.values.jfrog.tokenType) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
    const response = yield (0, node_fetch_1.default)(url, (0, exports.createDownloadInit)(authToken, authTokenType, 'application/octet-stream'));
    return response;
});
exports.downloadBinary = downloadBinary;
const downloadJson = (url, authToken = store_1.configStore.values.jfrog.token, authTokenType = store_1.configStore.values.jfrog.tokenType) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
    const response = yield (0, node_fetch_1.default)(url, (0, exports.createDownloadInit)(authToken, authTokenType, 'application/json'));
    return response;
});
exports.downloadJson = downloadJson;
